/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    Thanks : 4lj <4lj@flow.le.to> implements "tmpfile hold" mode

 *****************************************************************************/

#ifndef __GDDCONFIG_H__
#define __GDDCONFIG_H__

#include "param.h"
#include "gui.h"

enum{
    LOGTYPE_BIN,
    LOGTYPE_TEXT,
    LOGTYPE_TAGTEXT,
    LOGTYPE_HTML,
    LOGTYPE_NONFILTER
};
#define EXT_LOGTYPE_BIN         "txt"
#define EXT_LOGTYPE_TEXT        "txt"
#define EXT_LOGTYPE_TAGTEXT     "xml"
#define EXT_LOGTYPE_HTML        "html"
#define EXT_LOGTYPE_NONFILTER   "txt"

#define STR_LOGTYPE_BIN         "BIN"
#define STR_LOGTYPE_TEXT        "TEXT"
#define STR_LOGTYPE_TAGTEXT     "TAG"
#define STR_LOGTYPE_HTML        "HTML"
#define STR_LOGTYPE_NONFILTER   "NFLT"

enum{
    MODE_NORMAL,
    MODE_DEBUG
};

enum{
    PARAMMODE_CMDLINE,
    PARAMMODE_CFGFILE
};

#define MODE_DEBUG              0x00000001
#define MODE_DUMP               0x00000002
#define MODE_SECURE             0x00000004

#define STR_MODE_DUMP           "dump"
#define STR_MODE_DEBUG          "debug"
#define STR_MODE_SECURE         "secure"

#define C_LOGTYPE_BIN           'b'
#define C_LOGTYPE_TEXT          't'
#define C_LOGTYPE_TAGTEXT       'g'
#define C_LOGTYPE_HTML          'h'
#define C_LOGTYPE_NONFILTER     'n'

#define ENDOFPORT               0x0000

typedef struct{
    unsigned short int      pst;
    unsigned short int      ped;
    unsigned char           logtype;
}PORTTBL;

typedef struct{
    char                    sourceIP[MAXLEN_IPADDR];
    char                    destIP[MAXLEN_IPADDR];
    PORTTBL                 port[MAXNUM_PORT];
    char                    logfile[MAX_PATH];
    char                    errlog[MAX_PATH];
    char                    templogdir[MAX_PATH];
    char                    nit_dev[MAXLEN_NITDEV];
    char                    nic_name[MAXLEN_NICNAME];
    char                    action[MAXLEN_ACTION];
    char                    hold;   
    char                    startup_message;   
    unsigned int            mode;
    char                    enable_libpcapfilter;
    char                    param_mode;
    GDDGUI                  egui;
}GDDCONFIG;

#endif
